require File.dirname(__FILE__) + '/../test_helper'

class NoticeTest < Test::Unit::TestCase
  FIXTURES_PATH = File.dirname(__FILE__) + '/../fixtures'
  CHARSET = "utf-8"

  include ActionMailer::Quoting

  def setup
    ActionMailer::Base.delivery_method = :test
    ActionMailer::Base.perform_deliveries = true
    ActionMailer::Base.deliveries = []

    @expected = TMail::Mail.new
    @expected.set_content_type "text", "plain", { "charset" => CHARSET }
    @expected.mime_version = '1.0'
  end

  def test_notice
    @expected.subject = 'Notice#notice'
    @expected.body    = read_fixture('notice')
    @expected.date    = Time.now

    assert_equal @expected.encoded, Notice.create_notice(@expected.date).encoded
  end

  def test_welcome
    @expected.subject = 'Notice#welcome'
    @expected.body    = read_fixture('welcome')
    @expected.date    = Time.now

    assert_equal @expected.encoded, Notice.create_welcome(@expected.date).encoded
  end

  private
    def read_fixture(action)
      IO.readlines("#{FIXTURES_PATH}/notice/#{action}")
    end

    def encode(subject)
      quoted_printable(subject, CHARSET)
    end
end
