require File.dirname(__FILE__) + '/../test_helper'
require "#{RAILS_ROOT}/vendor/plugins/backgroundrb/backgroundrb.rb"
require "#{RAILS_ROOT}/lib/workers/post_worker"
require 'drb'

class PostWorkerTest < Test::Unit::TestCase
  fixtures :rooms
  fixtures :users, :memberships

  def setup
    @middleman = BackgrounDRb::MiddleMan.instance
    @middleman.set_sleep 0.05
    @middleman.start_timer
    @middleman.gc! Time.now

    @one_id = rooms(:one).id
  end

  def test_post
    job_key = @middleman.new_worker(:class => :post_worker, :args => { :id => @one_id })
    sleep 0.1 while @middleman.get_worker(job_key)

    assert_equal 2, Notice.deliveries.size
  end
end
